//+---------------------------------------------------------------------------------+
//+ Forex Bullseye                                                                      +
//+     2-                                   +
//+                                                                                 +
//+  :                                                              +
//+  ExtPeriodFastMA -                                           +
//+  ExtPeriodMiddleMA -                                        +
//+  ExtModeFastMA   -                                            +
//+  ExtModeMiddleMA   -                                         +
//+   : 0 = SMA, 1 = EMA, 2 = SMMA (), 3 = LWMA ()        +
//+  ExtPriceFastMA  -                                             +
//+  ExtPriceMiddleMA  -                                          +
//+   : 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = HL/2, 5 = HLC/3, 6 = HLCC/4 +
//+---------------------------------------------------------------------------------+
#property copyright "Copyright  2013"
#property link      ""

//----  
#property indicator_chart_window
#property indicator_buffers 5
//---- 
#property indicator_color1 Orange // 5
#property indicator_color2 Red       // 13
#property indicator_color3 SpringGreen       //  7
#property indicator_color4 DeepSkyBlue
#property indicator_color5 Red
#property indicator_width4 2
#property indicator_width5 2

//---- 
extern int                ExtPeriodFastMA   = 5;
extern int                ExtPeriodMiddleMA = 13;
extern int                ExtPeriodSlowMA   = 7;
extern ENUM_MA_METHOD     ExtModeFastMA     = MODE_EMA; 
extern ENUM_MA_METHOD     ExtModeMiddleMA   = MODE_EMA; 
extern ENUM_MA_METHOD     ExtModeSlowMA     = MODE_EMA; 
extern ENUM_APPLIED_PRICE ExtPriceFastMA    = 0;
extern ENUM_APPLIED_PRICE ExtPriceMiddleMA  = 5; 
extern ENUM_APPLIED_PRICE ExtPriceSlowMA    = 1;

extern bool               alertsOn           = true;
extern bool               alertsOnCurrent    = false;
extern bool               alertsMessage      = true;
extern bool               alertsSound        = true;
extern bool               alertsEmail        = false;
extern bool               alertsNotify       = false;
extern string             soundFile          = "alert.wav";

extern double             arrowsDisplacement = 2.0;



//---- 
double FastMA[];
double MiddMA[];
double SlowMA[];
double CrossUp[];
double CrossDn[];
double trend[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  IndicatorBuffers(6);
  SetIndexBuffer(0,FastMA);  SetIndexLabel(0,"MA" + ExtPeriodFastMA);
  SetIndexBuffer(1,MiddMA);  SetIndexLabel(1,"MA" + ExtPeriodMiddleMA);
  SetIndexBuffer(2,SlowMA);  SetIndexLabel(2,"Buy");
  SetIndexBuffer(3,CrossUp); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,233);
  SetIndexBuffer(4,CrossDn); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,234);
  SetIndexBuffer(5,trend);

  IndicatorShortName("Forex Bullseye(" + ExtPeriodFastMA + "," + ExtPeriodMiddleMA);
return ( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
    
    //
    //
    //
    //
    //
    
    for(int i = limit; i>=0; i--)
 	 {
       FastMA[i] = iMA(NULL,0,ExtPeriodFastMA,  0,ExtModeFastMA,  ExtPriceFastMA,i);
       MiddMA[i] = iMA(NULL,0,ExtPeriodMiddleMA,0,ExtModeMiddleMA,ExtPriceSlowMA,i);
       SlowMA[i] = iMA(NULL,0,ExtPeriodSlowMA,  0,ExtModeSlowMA,  ExtPriceSlowMA,i);
       double gap = iATR(NULL,0,20,i);
       
       trend[i] = trend[i+1];
       if (( FastMA[i  ] > MiddMA[i  ] ) &&
           ( FastMA[i+1] < MiddMA[i+1] ) &&
           ( FastMA[i+2] < MiddMA[i+2] ) && 
           ( FastMA[i+3] < MiddMA[i+3] )&&//  
           (NormalizeDouble(FastMA[i]-FastMA[i+3],4)>=0.0002))   trend[i] = 1;
       if (( FastMA[i  ] < MiddMA[i  ] ) &&
           ( FastMA[i+1] > MiddMA[i+1] ) &&
           ( FastMA[i+2] > MiddMA[i+2] )&& //  
           ( FastMA[i+3] > MiddMA[i+3] )&&
           ( NormalizeDouble(FastMA[i+3]- FastMA[i],4)>=0.0002)) trend[i] =-1;
          
         //
         //
         //
         //
         //
      
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = Low[i]  - arrowsDisplacement * gap;
         else  CrossDn[i] = High[i] + arrowsDisplacement * gap; 
    }
    
   //
   //
   //
   //
   //
         
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("Buy");
      else  doAlert("Sell");       
   }
return(0);
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Forex Bullseye ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Forex Bullseye "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

